#define HOST_VERSION 2
#define HASH(nick)	((tolower((nick)[0])&31)<<5 | (tolower((nick)[1])&31))

typedef struct hostcore_ HostCore;

struct hostcore_ {
    HostCore *next;
    char *nick;						/* Owner of the vHost */
    char *vHost;					/* Vhost for this user */
    char *creator;					/* Oper Nick of the oper who set the vhost */
    time_t time;						/* Date/Time vHost was set */
};

typedef enum{false,true} boolean;

void load_hs_dbase_v1(dbFILE *f);
void load_hs_dbase_v2(dbFILE *f);

static int guestnum;			/* Current guest number */
HostCore *head = NULL;		/* head of the HostCore list */
HostCore *createHostCorelist(HostCore *next, char *nick, char *vHost, char *creator, int32 tmp_time);
HostCore *findHostCore(HostCore *head, char *nick, boolean *found);
HostCore *insertHostCore(HostCore *head, HostCore *prev, char *nick, char *vHost, char *creator, int32 tmp_time);
HostCore *deleteHostCore(HostCore *head, HostCore *prev);

static void send_on(char *nick, char *vhost);
static void send_off(User *u);

static void do_help(User *u);
static void do_set(User *u);
static void do_on(User *u);
void do_on_id(User *u);
static void do_off(User *u);
static void do_del(User *u);
static void listOut(User *u);
void do_hs_sync(NickCore *nc,char *hostmask,char *creator,time_t time);
void do_setall(User *u);

/*************************************************************************/
static Command cmds[] = {
    { "HELP",			do_help,	NULL,	-1,		-1,-1,-1,-1 },
    { "SET",			do_set,		NULL,	HOST_HELP_SET,	-1,-1,-1,-1 },
    { "SETALL",			do_setall,	NULL,	HOST_HELP_SETALL,-1,-1,-1,-1 },
    { "ON",			do_on,		NULL,	HOST_HELP_ON,	-1,-1,-1,-1 },
    { "OFF",			do_off,		NULL,	HOST_HELP_OFF,	-1,-1,-1,-1 },
    { "DEL",			do_del,		NULL,	HOST_HELP_DEL,	-1,-1,-1,-1 },
    { "LIST",			listOut,	NULL,	HOST_HELP_LIST,	-1,-1,-1,-1 },
    { NULL }
};
/*************************************************************************/
